import { jsx as h, jsxs as x } from "react/jsx-runtime";
import o from "clsx";
import k, { useState as L } from "react";
const p = "av-button", U = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
}, T = "icon", w = "button", C = "link", S = ({
  type: e,
  size: t,
  labelRight: r,
  labelLeft: a,
  align: i
}) => {
  const d = "text-sm font-medium max-h-8 py-0", l = "text-base font-medium max-h-9 py-1", n = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case w:
      return o("px-4", {
        [d]: t === "small",
        [l]: t === "medium",
        [n]: t === "large"
      });
    case C:
      return o("px-4 text-center", {
        [d]: t === "small",
        [l]: t === "medium",
        [n]: t === "large"
      });
    case T:
      return o("inline-flex items-center", {
        "justify-center": i === "center",
        "justify-start": i === "left",
        "justify-end": i === "right",
        "h-6 w-6 p-0": t === "small" && !(r || a),
        "h-6 px-4 text-sm font-medium": t === "small" && (r || a),
        "h-8 w-8 p-1": t === "medium" && !(r || a),
        "h-8 px-4 text-base font-medium": t === "medium" && (r || a),
        "h-12 w-12 p-2": t === "large" && !(r || a),
        "h-12 px-4 text-lg font-medium": t === "large" && (r || a)
      });
  }
}, W = ({
  mode: e,
  noBackground: t,
  noTruncate: r,
  variant: a
}) => {
  if (t)
    return "not-prose rounded-full";
  if (a === "primary")
    return o("not-prose rounded-full", {
      truncate: !r,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return o("not-prose rounded-full", {
      truncate: !r,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return o("not-prose rounded-full", {
      truncate: !r,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
}, D = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (r === "secondary")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (r === "danger")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
}, $ = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return o("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (r === "secondary")
    return o("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (r === "danger")
    return o("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
}, A = ({
  mode: e,
  noBorder: t,
  variant: r
}) => {
  if (t)
    return "border border-transparent";
  if (r === "primary")
    return o("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (r === "secondary")
    return o("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (r === "danger")
    return o("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
}, O = ({ focusMode: e }) => o("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), B = ({
  type: e,
  className: t,
  raw: r,
  mode: a,
  focusMode: i,
  disabled: d,
  fullWidth: l,
  size: n,
  noBorder: u,
  labelRight: s,
  labelLeft: b,
  spacing: m,
  noBackground: g,
  variant: c,
  noTruncate: v,
  align: f
}) => (c || (c = "primary"), r ? o(p, t) : o(
  p,
  t,
  U(m),
  W({ mode: a, variant: c, noBackground: g, noTruncate: v }),
  S({ type: e, size: n, labelRight: s, labelLeft: b, align: f }),
  A({ mode: a, variant: c, noBorder: u }),
  O({ focusMode: i }),
  D({ mode: a, variant: c, disabled: d }),
  $({ mode: a, variant: c, disabled: d }),
  {
    "w-full": l,
    "disabled:cursor-not-allowed disabled:opacity-50": d
  }
)), V = (e, t, r) => {
  var a;
  !t && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof r == "function" && r(e);
}, y = k.forwardRef((e, t) => {
  const { onClick: r, noInternalClick: a = !1, ...i } = e;
  return /* @__PURE__ */ h(
    "button",
    {
      ref: t,
      onClick: (d) => {
        V(d, a, r);
      },
      ...i
    }
  );
});
y.displayName = "BaseButton";
const N = k.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: a = "system",
    fullWidth: i = !1,
    className: d,
    size: l = "medium",
    raw: n = !1,
    noBorder: u = !1,
    spacing: s,
    variant: b = "primary",
    noTruncate: m = !1,
    ...g
  }, c) => {
    const v = B({
      type: w,
      mode: r,
      focusMode: a,
      fullWidth: i,
      disabled: t,
      raw: n,
      className: d,
      size: l,
      noBorder: u,
      spacing: s,
      variant: b,
      noTruncate: m
    });
    return /* @__PURE__ */ h(
      y,
      {
        ref: c,
        className: v,
        disabled: t,
        ...g,
        children: e
      }
    );
  }
);
N.displayName = "Button";
/*!
  @versini/ui-button v1.1.10
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.1.10",
    buildTime: "09/28/2024 06:29 PM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const F = k.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: a = "system",
    fullWidth: i = !1,
    className: d,
    type: l = "button",
    raw: n = !1,
    noBorder: u = !1,
    "aria-label": s,
    label: b,
    size: m = "medium",
    labelRight: g,
    labelLeft: c,
    spacing: v,
    noBackground: f = !1,
    align: _ = "center",
    active: E = !1,
    ...R
  }, I) => {
    const M = B({
      type: T,
      mode: r,
      focusMode: a,
      fullWidth: i,
      disabled: t,
      raw: n,
      className: d,
      noBorder: u,
      size: m,
      labelRight: g,
      labelLeft: c,
      spacing: v,
      noBackground: f,
      align: _
    }), z = o({
      "text-copy-accent-dark": r === "light" && !n,
      "text-copy-light": r === "dark" && !n,
      "text-copy-accent-dark dark:text-copy-light": r === "alt-system" && !n,
      "text-copy-light dark:text-copy-accent-dark": r === "system" && !n
    }), j = E ? o(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": r === "dark",
        "after:border-table-light": r === "light",
        "after:border-table-dark dark:after:border-table-light": r === "system",
        "after:border-table-light dark:after:border-table-dark": r === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ h("div", { className: j, children: /* @__PURE__ */ x(
      y,
      {
        ref: I,
        className: M,
        disabled: t,
        type: l,
        "aria-label": s || b,
        ...R,
        children: [
          c && /* @__PURE__ */ h("span", { className: "pr-2", children: c }),
          /* @__PURE__ */ h("div", { className: z, children: e }),
          g && /* @__PURE__ */ h("span", { className: "pl-2", children: g })
        ]
      }
    ) });
  }
);
F.displayName = "ButtonSort";
const G = 200, H = ({
  string: e,
  idealLength: t = G
}) => {
  if (e.length <= t)
    return { string: e, isTruncated: !1 };
  if (e.charAt(t) === " ")
    return { string: e.slice(0, t), isTruncated: !0 };
  const i = e.slice(t).search(" ");
  return {
    string: e.slice(0, t + i),
    isTruncated: !0
  };
}, K = ({
  children: e,
  length: t = 200,
  mode: r = "system",
  focusMode: a = "system"
}) => {
  const [i, d] = L(!1);
  if (typeof e != "string")
    return e;
  const { string: l, isTruncated: n } = H({
    string: e,
    idealLength: t
  });
  return /* @__PURE__ */ x("span", { children: [
    i ? e : l,
    n && /* @__PURE__ */ h(
      N,
      {
        mode: r,
        focusMode: a,
        spacing: { l: 2 },
        size: "small",
        onClick: (s) => {
          s.preventDefault(), d(!i);
        },
        children: i ? "less..." : "more..."
      }
    )
  ] });
};
export {
  K as Truncate
};
